package org.jutils.collection;

import java.util.*;
/**
 * <p>------------------------------------------------------------------------------<br>
 * Name:     	ExtendedEnumerator<br>
 * Project:  	jutils.org<br>
 * Copyright:	jutils, see license file<br>
 * Comment:		That's what we all do expect from an Enumerator, gee?!?
 * Creation date: (05.07.2000 12:10:19)   <br>
 * Version:   <pre>$Id: ExtendedEnumerator.java,v 1.2 2000/09/01 17:55:35 winkler Exp $</pre> <br>
 * ------------------------------------------------------------------------------<p>
 * @author: M.Winkler, doubleSlash GmbH
 */
public interface ExtendedEnumerator extends Enumeration, Iterator {



    /**
     * The number of elements in the instance.
     * Creation date: (05.07.2000 12:10:33)<br>
     * @author: M.Winkler, doubleSlash GmbH
     *
     */
    int count();



    /**
     * Returns the amount of remaining elements.
     * Creation date: (05.07.2000 12:57:11)<br>
     * @author: M.Winkler, doubleSlash GmbH
     *
     * @return int
     */
    int remaining();



    /**
     * To restart enumeration from the beginning.
     * Creation date: (05.07.2000 12:10:58)<br>
     * @author: M.Winkler, doubleSlash GmbH
     *
     */
    void restart();



    /**
     * Copies the contents of this Enumerator to a Vector.
     * Creation date: (05.07.2000 13:28:41)<br>
     * @author: M.Winkler, doubleSlash GmbH
     *
     * @return java.util.Vector
     */
    Vector toVector();



    /**
     * Copies the contents of this Enumerator to the passed Vector.
     * Creation date: (05.07.2000 13:29:17)<br>
     * @author: M.Winkler, doubleSlash GmbH
     *
     * @return java.util.Vector the passed Vector
     * @param destination java.util.Vector
     */
    Vector toVector(Vector destination);
}

